<?php

namespace app\ic;

use app\ThemesUtil;
use engine\http\HtmlResponse;
use engine\http\Response;
use Twig\Loader\FilesystemLoader;
use Twig\Loader\LoaderInterface;

class InvisibleCollegeSkin
    extends \engine\skin\FeaturedSkin
{
    public function __construct() {
        parent::__construct();

    }

    protected function getTwigLoader(): LoaderInterface {
        $twig_loader = new FilesystemLoader(APP_ROOT.'/src/skins/ic', APP_ROOT);
        $twig_loader->addPath(APP_ROOT.'/src/skins/foreignone', 'foreignone');
        return $twig_loader;
    }

    /*
    public function renderPage(string $template, array $vars = []): Response {
        $this->exportStrings(['4in1']);
        $this->applyGlobals();

        // render body first
        $b = $this->renderBody($template, $vars);

        // then everything else
        $h = $this->renderHeader();
        $f = $this->renderFooter();

        return new HtmlResponse($h.$b.$f);
    }

    protected function renderHeader(): string {
        global $config;

        $body_class = [];
        if ($this->options->fullWidth)
            $body_class[] = 'full-width';
        else if ($this->options->wide)
            $body_class[] = 'wide';

        $vars = [
            'title' => $this->title,
            'meta_html' => $this->meta->getHtml(),
            'static_html' => $this->getHeaderStaticTags(),
            'svg_html' => $this->getSVGTags(),
            'render_options' => $this->options->getOptions(),
            'app_config' => [
                'domain' => $config['domain'],
                'devMode' => $config['is_dev'],
                'cookieHost' => $config['cookie_host'],
            ],
            'body_class' => $body_class,
            'theme' => ThemesUtil::getUserTheme(),
        ];

        return $this->doRender('header.twig', $vars);
    }

    protected function renderBody(string $template, array $vars): string {
        return $this->doRender($template, $this->vars + $vars);
    }

    protected function renderFooter(): string {
        global $config;

        $exec_time = microtime(true) - START_TIME;
        $exec_time = round($exec_time, 4);

        $footer_vars = [
            'exec_time' => $exec_time,
            'render_options' => $this->options->getOptions(),
            'admin_email' => $config['admin_email'],
            // 'lang_json' => json_encode($this->getLangKeys(), JSON_UNESCAPED_UNICODE),
            // 'static_config' => $this->getStaticConfig(),
            'script_html' => $this->getFooterScriptTags(),
            'this_page_url' => $_SERVER['REQUEST_URI'],
            'theme' => ThemesUtil::getUserTheme(),
        ];
        return $this->doRender('footer.twig', $footer_vars);
    }
    */
}